首页 > 代码库 > 2016 年沈阳网络赛---QSC and Master(区间DP)
2016 年沈阳网络赛---QSC and Master(区间DP)
题目链接
http://acm.hdu.edu.cn/showproblem.php?pid=5900
Problem Description
Every school has some legends, Northeastern University is the same.
Enter from the north gate of Northeastern University,You are facing the main building of Northeastern University.Ninety-nine percent of the students have not been there,It is said that there is a monster in it.
QSCI am a curious NEU_ACMer,This is the story he told us.
It’s a certain period,QSCI am in a dark night, secretly sneaked into the East Building,hope to see the master.After a serious search,He finally saw the little master in a dark corner. The master said:
“You and I, we‘re interfacing.please solve my little puzzle!
There are N pairs of numbers,Each pair consists of a key and a value,Now you need to move out some of the pairs to get the score.You can move out two continuous pairs,if and only if their keys are non coprime(their gcd is not one).The final score you get is the sum of all pair’s value which be moved out. May I ask how many points you can get the most?
The answer you give is directly related to your final exam results~The young man~”
QSC is very sad when he told the story,He failed his linear algebra that year because he didn‘t work out the puzzle.
Could you solve this puzzle?
(Data range:1<=N<=300
1<=Ai.key<=1,000,000,000
0<Ai.value<=1,000,000,000)
Enter from the north gate of Northeastern University,You are facing the main building of Northeastern University.Ninety-nine percent of the students have not been there,It is said that there is a monster in it.
QSCI am a curious NEU_ACMer,This is the story he told us.
It’s a certain period,QSCI am in a dark night, secretly sneaked into the East Building,hope to see the master.After a serious search,He finally saw the little master in a dark corner. The master said:
“You and I, we‘re interfacing.please solve my little puzzle!
There are N pairs of numbers,Each pair consists of a key and a value,Now you need to move out some of the pairs to get the score.You can move out two continuous pairs,if and only if their keys are non coprime(their gcd is not one).The final score you get is the sum of all pair’s value which be moved out. May I ask how many points you can get the most?
The answer you give is directly related to your final exam results~The young man~”
QSC is very sad when he told the story,He failed his linear algebra that year because he didn‘t work out the puzzle.
Could you solve this puzzle?
(Data range:1<=N<=300
1<=Ai.key<=1,000,000,000
0<Ai.value<=1,000,000,000)
Input
First line contains a integer T,means there are T(1≤T≤10) test case。
Each test case start with one integer N . Next line contains N integers,means Ai.key.Next line contains N integers,means Ai.value.
Each test case start with one integer N . Next line contains N integers,means Ai.key.Next line contains N integers,means Ai.value.
Output
For each test case,output the max score you could get in a line.
Sample Input
3
3
1 2 3
1 1 1
3
1 2 4
1 1 1
4
1 3 4 3
1 1 1 1
Sample Output
0
2
0
Source
2016 ACM/ICPC Asia Regional Shenyang Online
Recommend
wange2014 | We have carefully selected several similar problems for you: 5901 5899 5898 5897 5896
题意:
n
个pair<int , int>
,每次可以选相邻两个pair
。如果他们的first
不互质就可以把它们都删掉,并且获得second
之和的分数,问最大得分。思路:区间DP,类似于括号匹配的题(一个括号序列,要求添加最少的括号使这个括号序列匹配) 定义dp[i][j] 表示i~j的区间能得的最大分,那么有状态转移方程:dp[i][j]=dp[i][k]+dp[k+1][j] 另外注意特判取两边时的情形,即区间 i+1~j-1 都删除了(判断条件dp[i+1][j-1]==sum(b[i+1]+....+b[j-1])),如果gcd(a[i],a[j])>1 dp[i][j]=dp[i+1][j-1]+b[i]+b[j];
代码如下:
#include <iostream>#include <algorithm>#include <stdio.h>#include <queue>#include <cmath>#include <string.h>using namespace std;long long a[305],b[305];long long dp[305][305];long long sum[305];long long GCD(long long a,long long b){ return (b==0)?a:GCD(b,a%b);}int main(){ int T,N; cin>>T; while(T--) { scanf("%d",&N); for(int i=1;i<=N;i++) scanf("%lld",&a[i]); sum[0]=0; for(int i=1;i<=N;i++) { scanf("%lld",&b[i]); sum[i]=sum[i-1]+b[i]; } memset(dp,0,sizeof(dp)); for(int len=1;len<N;len++) { for(int i=1;i+len<=N;i++) { if(sum[i+len-1]-sum[i]==dp[i+1][i+len-1]) { dp[i][i+len]=dp[i+1][i+len-1]; if(GCD(a[i],a[i+len])>1) dp[i][i+len]+=b[i]+b[i+len]; } for(int k=i;k<i+len;k++) { dp[i][i+len]=max(dp[i][i+len],dp[i][k]+dp[k+1][i+len]); } } } printf("%lld\n",dp[1][N]); } return 0;}
2016 年沈阳网络赛---QSC and Master(区间DP)
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。